import tempfile
from .. import lib

config_sample = \
"""
##
# A sample config file.
##
# This provides a good = test for manipulate.

#shared_buffers = 4500
search_path = window,$user,public
shared_buffers = 2500

port = 5234
listen_addresses = 'localhost'
listen_addresses = '*'
"""

def mapping_test(test, m):
	m['foo'] = 'bar'
	test.fail_if_not_equal(m['foo'], 'bar')

	m.update({'foo':'meh', 'bar':'bleh'})
	test.fail_if_not_equal(m['foo'], 'meh')
	test.fail_if_not_equal(m['bar'], 'bleh')
	test.fail_if_not_equal(m['bar'], 'bleh')

	test.fail_if_not_equal(m.getset(()), {})
	test.fail_if_not_equal(m.getset(('foo','port')), {'foo':'meh', 'port':'5234'})

def test_File(test):
	with tempfile.NamedTemporaryFile(encoding='utf-8',mode='w') as tf:
		tf.write(config_sample)
		tf.flush()
		m = lib.File(tf.name)
		mapping_test(test, m)

if __name__ == '__main__':
	from dev import libtest; libtest.execmodule()
